/*
 * Copyright 2003-2004 The Apache Software Foundation.

 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *		http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * This file was auto-generated by the Axis C++ Web Service Generator (WSDL2Ws)
 * This file contains Web Service Wrapper implementations
 */

#include "XSDElementWrapper.hpp"

XSDElementWrapper::XSDElementWrapper()
{
	pWs = new XSDElement();
}

XSDElementWrapper::~XSDElementWrapper()
{
	delete pWs;
}

/*implementation of WrapperClassHandler interface*/
void XSDElementWrapper::onFault(void *pMsg)
{
	pWs->onFault();
}

int XSDElementWrapper::init()
{
	pWs->init();
	return AXIS_SUCCESS;
}

int XSDElementWrapper::fini()
{
	pWs->fini();
	return AXIS_SUCCESS;
}


/*
 * This method invokes the right service method 
 */
int XSDElementWrapper::invoke(void *pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	const AxisChar *method = mc->getOperationName();
	if (0 == strcmp(method, "setGetDataInt"))
		return setGetDataInt(mc);
	else if (0 == strcmp(method, "setGetDataUnsignedInt"))
		return setGetDataUnsignedInt(mc);
	else if (0 == strcmp(method, "setGetDataLong"))
		return setGetDataLong(mc);
	else if (0 == strcmp(method, "setGetDataUnsignedLong"))
		return setGetDataUnsignedLong(mc);
	else if (0 == strcmp(method, "setGetDataDouble"))
		return setGetDataDouble(mc);
	else if (0 == strcmp(method, "setGetDataFloat"))
		return setGetDataFloat(mc);
	else if (0 == strcmp(method, "setGetDataByte"))
		return setGetDataByte(mc);
	else if (0 == strcmp(method, "setGetDataUnsignedByte"))
		return setGetDataUnsignedByte(mc);
	else if (0 == strcmp(method, "setGetDataBoolean"))
		return setGetDataBoolean(mc);
	else if (0 == strcmp(method, "setGetDataString"))
		return setGetDataString(mc);
	else if (0 == strcmp(method, "setGetDataShort"))
		return setGetDataShort(mc);
	else if (0 == strcmp(method, "setGetDataUnsignedShort"))
		return setGetDataUnsignedShort(mc);
	else if (0 == strcmp(method, "setGetDateTimeType"))
		return setGetDateTimeType(mc);
	else if (0 == strcmp(method, "setGetDateType"))
		return setGetDateType(mc);
	else if (0 == strcmp(method, "setGetDataDurationType"))
		return setGetDataDurationType(mc);
	else if (0 == strcmp(method, "setGetTimeType"))
		return setGetTimeType(mc);
	else if (0 == strcmp(method, "setGetBase64BinaryType"))
		return setGetBase64BinaryType(mc);
	else if (0 == strcmp(method, "setGetHexBinary"))
		return setGetHexBinary(mc);
	else if (0 == strcmp(method, "setGetDecimalType"))
		return setGetDecimalType(mc);
	else if (0 == strcmp(method, "setGetIntegerType"))
		return setGetIntegerType(mc);
	else if (0 == strcmp(method, "setQNameType"))
		return setQNameType(mc);
	else if (0 == strcmp(method, "getQNameType"))
		return getQNameType(mc);
	else if (0 == strcmp(method, "setAnyURIType"))
		return setAnyURIType(mc);
	else if (0 == strcmp(method, "getAnyURIType"))
		return getAnyURIType(mc);
	else return AXIS_FAIL;
}


/*Methods corresponding to the web service methods*/

/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDataInt(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDataInt", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDataIntResponse", "http://xsdelement.test.apache.org");
	xsd__int v0 = *(pIWSDZ->getElementAsInt("arg_0_2",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__int ret = pWs->setGetDataInt(v0);
	return pIWSSZ->addOutputParam("setGetDataIntReturn", (void*)&ret, XSD_INT);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDataUnsignedInt(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDataUnsignedInt", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDataUnsignedIntResponse", "http://xsdelement.test.apache.org");
	xsd__unsignedInt v0 = *(pIWSDZ->getElementAsUnsignedInt("arg_0_u2",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__unsignedInt ret = pWs->setGetDataUnsignedInt(v0);
	return pIWSSZ->addOutputParam("setGetDataUnsignedIntReturn", (void*)&ret, XSD_UNSIGNEDINT);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDataLong(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDataLong", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDataLongResponse", "http://xsdelement.test.apache.org");
	xsd__long v0 = *(pIWSDZ->getElementAsLong("arg_0_5",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__long ret = pWs->setGetDataLong(v0);
	return pIWSSZ->addOutputParam("setGetDataLongReturn", (void*)&ret, XSD_LONG);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDataUnsignedLong(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDataUnsignedLong", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDataUnsignedLongResponse", "http://xsdelement.test.apache.org");
	xsd__unsignedLong v0 = *(pIWSDZ->getElementAsUnsignedLong("arg_0_u5",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__unsignedLong ret = pWs->setGetDataUnsignedLong(v0);
	return pIWSSZ->addOutputParam("setGetDataUnsignedLongReturn", (void*)&ret, XSD_UNSIGNEDLONG);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDataDouble(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDataDouble", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDataDoubleResponse", "http://xsdelement.test.apache.org");
	xsd__double v0 = *(pIWSDZ->getElementAsDouble("arg_0_8",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__double ret = pWs->setGetDataDouble(v0);
	return pIWSSZ->addOutputParam("setGetDataDoubleReturn", (void*)&ret, XSD_DOUBLE);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDataFloat(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDataFloat", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDataFloatResponse", "http://xsdelement.test.apache.org");
	xsd__float v0 = *(pIWSDZ->getElementAsFloat("arg_0_11",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__float ret = pWs->setGetDataFloat(v0);
	return pIWSSZ->addOutputParam("setGetDataFloatReturn", (void*)&ret, XSD_FLOAT);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDataByte(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDataByte", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDataByteResponse", "http://xsdelement.test.apache.org");
	xsd__byte v0 = *(pIWSDZ->getElementAsByte("arg_0_14",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__byte ret = pWs->setGetDataByte(v0);
	return pIWSSZ->addOutputParam("setGetDataByteReturn", (void*)&ret, XSD_BYTE);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDataUnsignedByte(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDataUnsignedByte", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDataUnsignedByteResponse", "http://xsdelement.test.apache.org");
	xsd__unsignedByte v0 = *(pIWSDZ->getElementAsUnsignedByte("arg_0_u14",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__unsignedByte ret = pWs->setGetDataUnsignedByte(v0);
	return pIWSSZ->addOutputParam("setGetDataUnsignedByteReturn", (void*)&ret, XSD_UNSIGNEDBYTE);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDataBoolean(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDataBoolean", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDataBooleanResponse", "http://xsdelement.test.apache.org");
	xsd__boolean v0 = *(pIWSDZ->getElementAsBoolean("arg_0_17",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__boolean ret = pWs->setGetDataBoolean(v0);
	return pIWSSZ->addOutputParam("setGetDataBooleanReturn", (void*)&ret, XSD_BOOLEAN);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDataString(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDataString", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDataStringResponse", "http://xsdelement.test.apache.org");
	xsd__string v0 = pIWSDZ->getElementAsString("arg_0_23",0);
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__string ret = pWs->setGetDataString(v0);
	return pIWSSZ->addOutputParam("setGetDataStringReturn", (void*)ret, XSD_STRING);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDataShort(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDataShort", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDataShortResponse", "http://xsdelement.test.apache.org");
	xsd__short v0 = *(pIWSDZ->getElementAsShort("arg_0_26",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__short ret = pWs->setGetDataShort(v0);
	return pIWSSZ->addOutputParam("setGetDataShortReturn", (void*)&ret, XSD_SHORT);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDataUnsignedShort(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDataUnsignedShort", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDataUnsignedShortResponse", "http://xsdelement.test.apache.org");
	xsd__unsignedShort v0 = *(pIWSDZ->getElementAsUnsignedShort("arg_0_u26",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__unsignedShort ret = pWs->setGetDataUnsignedShort(v0);
	return pIWSSZ->addOutputParam("setGetDataUnsignedShortReturn", (void*)&ret, XSD_UNSIGNEDSHORT);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDateTimeType(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDateTimeType", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDateTimeTypeResponse", "http://xsdelement.test.apache.org");
	xsd__dateTime v0 = *(pIWSDZ->getElementAsDateTime("arg_0_32",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__dateTime ret = pWs->setGetDateTimeType(v0);
	return pIWSSZ->addOutputParam("setGetDateTimeTypeReturn", (void*)&ret, XSD_DATETIME);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDateType(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDateType", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDateTypeResponse", "http://xsdelement.test.apache.org");
	xsd__date v0 = *(pIWSDZ->getElementAsDate("arg_0_35",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__date ret = pWs->setGetDateType(v0);
	return pIWSSZ->addOutputParam("setGetDateTypeReturn", (void*)&ret, XSD_DATE);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDataDurationType(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDataDurationType", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDataDurationTypeResponse", "http://xsdelement.test.apache.org");
	xsd__duration v0 = *(pIWSDZ->getElementAsDuration("arg_0_d35",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__duration ret = pWs->setGetDataDurationType(v0);
	return pIWSSZ->addOutputParam("setGetDataDurationTypeReturn", (void*)&ret, XSD_DURATION);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetTimeType(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetTimeType", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetTimeTypeResponse", "http://xsdelement.test.apache.org");
	xsd__time v0 = *(pIWSDZ->getElementAsTime("arg_0_38",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__time ret = pWs->setGetTimeType(v0);
	return pIWSSZ->addOutputParam("setGetTimeTypeReturn", (void*)&ret, XSD_TIME);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetBase64BinaryType(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetBase64BinaryType", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetBase64BinaryTypeResponse", "http://xsdelement.test.apache.org");
	xsd__base64Binary v0 = *(pIWSDZ->getElementAsBase64Binary("arg_0_41",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__base64Binary ret = pWs->setGetBase64BinaryType(v0);
	return pIWSSZ->addOutputParam("setGetBase64BinaryTypeReturn", (void*)&ret, XSD_BASE64BINARY);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetHexBinary(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetHexBinary", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetHexBinaryResponse", "http://xsdelement.test.apache.org");
	xsd__hexBinary v0 = *(pIWSDZ->getElementAsHexBinary("arg_0_44",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__hexBinary ret = pWs->setGetHexBinary(v0);
	return pIWSSZ->addOutputParam("setGetHexBinaryReturn", (void*)&ret, XSD_HEXBINARY);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetDecimalType(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetDecimalType", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetDecimalTypeResponse", "http://xsdelement.test.apache.org");
	xsd__decimal v0 = *(pIWSDZ->getElementAsDecimal("arg_0_47",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__decimal ret = pWs->setGetDecimalType(v0);
	return pIWSSZ->addOutputParam("setGetDecimalTypeReturn", (void*)&ret, XSD_DECIMAL);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setGetIntegerType(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setGetIntegerType", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setGetIntegerTypeResponse", "http://xsdelement.test.apache.org");
	xsd__integer v0 = *(pIWSDZ->getElementAsLong("arg_0_50",0));
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__integer ret = pWs->setGetIntegerType(v0);
	return pIWSSZ->addOutputParam("setGetIntegerTypeReturn", (void*)&ret, XSD_INTEGER);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setQNameType(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setQNameType", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setQNameTypeResponse", "http://xsdelement.test.apache.org");
	xsd__QName v0 = pIWSDZ->getElementAsString("arg_0_52",0);
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	pWs->setQNameType(v0);
	return AXIS_SUCCESS;
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::getQNameType(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("getQNameType", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("getQNameTypeResponse", "http://xsdelement.test.apache.org");
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__QName ret = pWs->getQNameType();
	return pIWSSZ->addOutputParam("getQNameTypeReturn", (void*)ret, XSD_QNAME);
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::setAnyURIType(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("setAnyURIType", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("setAnyURITypeResponse", "http://xsdelement.test.apache.org");
	xsd__anyURI v0 = pIWSDZ->getElementAsString("arg_0_a52",0);
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	pWs->setAnyURIType(v0);
	return AXIS_SUCCESS;
	}
	catch(...){
	}
}


/*
 * This method wrap the service method 
 */
int XSDElementWrapper::getAnyURIType(void* pMsg)
{
	IMessageData* mc = (IMessageData*)pMsg;
	int nStatus;
	IWrapperSoapSerializer* pIWSSZ = NULL;
	mc->getSoapSerializer(&pIWSSZ);
	if (!pIWSSZ) return AXIS_FAIL;
	IWrapperSoapDeSerializer* pIWSDZ = NULL;
	mc->getSoapDeSerializer(&pIWSDZ);
	if (!pIWSDZ) return AXIS_FAIL;
	/* check whether we have got correct message */
	if (AXIS_SUCCESS != pIWSDZ->checkMessageBody("getAnyURIType", "http://xsdelement.test.apache.org")) return AXIS_FAIL;
	pIWSSZ->createSoapMethod("getAnyURITypeResponse", "http://xsdelement.test.apache.org");
	if (AXIS_SUCCESS != (nStatus = pIWSDZ->getStatus())) return nStatus;
	try
	{
	xsd__anyURI ret = pWs->getAnyURIType();
	return pIWSSZ->addOutputParam("getAnyURITypeReturn", (void*)ret, XSD_ANYURI);
	}
	catch(...){
	}
}

